#include "TQStringUtils.h"

TString TQStringUtils::format(const char *va_(fmt), ...){
	// format a string - analog to TString::Format
	va_list ap;
	va_start(ap, va_(fmt));
	TString str(vaFormat(va_(fmt), ap));
	va_end(ap);
	return str;
}


char* TQStringUtils::vaFormat(const char *fmt, va_list ap){
	// format a string - variadic variant of TString::Format
	// analog to (private) function TString::FormatImp
	
	Ssiz_t buflen = 20 + strlen(fmt);    // pick a number, any strictly positive number
	char* buffer = (char*)malloc(buflen*sizeof(char));
	
	va_list sap;
	R__VA_COPY(sap, ap);
	bool done = false;

	int n, vc = 0;
	do {
		n = vsnprintf(buffer, buflen, fmt, ap);
		// old vsnprintf's return -1 if string is truncated new ones return
		// total number of characters that would have been written
		if (n == -1 || n >= buflen) {
			if (n == -1)
				buflen *= 2;
			else
				buflen = n+1;
			buffer = (char*)realloc(buffer,buflen*sizeof(char));
			va_end(ap);
			R__VA_COPY(ap, sap);
			vc = 1;
		} else {
			done = true;
		}
	} while(!done);
	
	va_end(sap);
	if (vc)	va_end(ap);
	
	return buffer;
}
